// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Modbus.idl.

package com.raritan.idl.devsettings;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Modbus_2_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("devsettings.Modbus:2.0.0", null);

  public static final int ERR_INVALID_PARAM = 1;

  static public class Capabilities implements Cloneable {
    public Capabilities() {
      this.hasModbusSerial = new Boolean(false);
    }

    public Object clone() {
      Capabilities copy = new Capabilities();

      copy.hasModbusSerial = this.hasModbusSerial;

      return copy;
    }

    public boolean hasModbusSerial;
  }

  public class GetCapabilitiesResult {
    public com.raritan.idl.devsettings.Modbus_2_0_0.Capabilities _ret_;
  }

  GetCapabilitiesResult getCapabilities() throws Exception;

  AsyncRequest getCapabilities(AsyncRpcResponse<GetCapabilitiesResult> rsp);

  AsyncRequest getCapabilities(AsyncRpcResponse<GetCapabilitiesResult> rsp, RpcCtrl rpcCtrl);


  static public class TcpSettings implements Cloneable {
    public TcpSettings() {
      this.readonly = new Boolean(false);
    }

    public Object clone() {
      TcpSettings copy = new TcpSettings();

      copy.readonly = this.readonly;

      return copy;
    }

    public boolean readonly;
  }

  public enum Parity {
    NONE,
    EVEN,
    ODD;
  }

  static public class SerialSettings implements Cloneable {
    public SerialSettings() {
      this.enabled = new Boolean(false);
      this.baudrate = new Integer(0);
      this.parity = com.raritan.idl.devsettings.Modbus_2_0_0.Parity.values()[0];
      this.stopbits = new Integer(0);
      this.readonly = new Boolean(false);
    }

    public Object clone() {
      SerialSettings copy = new SerialSettings();

      copy.enabled = this.enabled;
      copy.baudrate = this.baudrate;
      copy.parity = this.parity;
      copy.stopbits = this.stopbits;
      copy.readonly = this.readonly;

      return copy;
    }

    public boolean enabled;
    public int baudrate;
    public com.raritan.idl.devsettings.Modbus_2_0_0.Parity parity;
    public int stopbits;
    public boolean readonly;
  }

  static public class Settings implements Cloneable {
    public Settings() {
      this.tcp = new com.raritan.idl.devsettings.Modbus_2_0_0.TcpSettings();
      this.serial = new com.raritan.idl.devsettings.Modbus_2_0_0.SerialSettings();
      this.primaryUnitId = new Integer(0);
    }

    public Object clone() {
      Settings copy = new Settings();

      Object tcpCopy = this.tcp.clone();
      copy.tcp = (com.raritan.idl.devsettings.Modbus_2_0_0.TcpSettings) tcpCopy;
      Object serialCopy = this.serial.clone();
      copy.serial = (com.raritan.idl.devsettings.Modbus_2_0_0.SerialSettings) serialCopy;
      copy.primaryUnitId = this.primaryUnitId;

      return copy;
    }

    public com.raritan.idl.devsettings.Modbus_2_0_0.TcpSettings tcp;
    public com.raritan.idl.devsettings.Modbus_2_0_0.SerialSettings serial;
    public int primaryUnitId;
  }

  public class GetSettingsResult {
    public com.raritan.idl.devsettings.Modbus_2_0_0.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.devsettings.Modbus_2_0_0.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.devsettings.Modbus_2_0_0.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.devsettings.Modbus_2_0_0.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

}
