// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Inlet.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Inlet_2_0_5 extends com.raritan.idl.pdumodel.EDevice {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet:2.0.5", null);

  static public class MetaData implements Cloneable {
    public MetaData() {
      this.label = new String();
      this.plugType = new String();
      this.namePlate = new com.raritan.idl.pdumodel.Nameplate_2_0_0();
      this.rating = new com.raritan.idl.pdumodel.Rating_2_0_0();
    }

    public Object clone() {
      MetaData copy = new MetaData();

      copy.label = this.label;
      copy.plugType = this.plugType;
      Object namePlateCopy = this.namePlate.clone();
      copy.namePlate = (com.raritan.idl.pdumodel.Nameplate_2_0_0) namePlateCopy;
      Object ratingCopy = this.rating.clone();
      copy.rating = (com.raritan.idl.pdumodel.Rating_2_0_0) ratingCopy;

      return copy;
    }

    public String label;
    public String plugType;
    public com.raritan.idl.pdumodel.Nameplate_2_0_0 namePlate;
    public com.raritan.idl.pdumodel.Rating_2_0_0 rating;
  }

  static public class Sensors implements Cloneable {
    public Sensors() {
      this.voltage = null;
      this.current = null;
      this.peakCurrent = null;
      this.residualCurrent = null;
      this.residualDCCurrent = null;
      this.activePower = null;
      this.reactivePower = null;
      this.apparentPower = null;
      this.powerFactor = null;
      this.displacementPowerFactor = null;
      this.activeEnergy = null;
      this.apparentEnergy = null;
      this.unbalancedCurrent = null;
      this.lineFrequency = null;
      this.phaseAngle = null;
      this.crestFactor = null;
      this.powerQuality = null;
      this.surgeProtectorStatus = null;
      this.residualCurrentStatus = null;
    }

    public Object clone() {
      Sensors copy = new Sensors();

      copy.voltage = this.voltage;
      copy.current = this.current;
      copy.peakCurrent = this.peakCurrent;
      copy.residualCurrent = this.residualCurrent;
      copy.residualDCCurrent = this.residualDCCurrent;
      copy.activePower = this.activePower;
      copy.reactivePower = this.reactivePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.displacementPowerFactor = this.displacementPowerFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.apparentEnergy = this.apparentEnergy;
      copy.unbalancedCurrent = this.unbalancedCurrent;
      copy.lineFrequency = this.lineFrequency;
      copy.phaseAngle = this.phaseAngle;
      copy.crestFactor = this.crestFactor;
      copy.powerQuality = this.powerQuality;
      copy.surgeProtectorStatus = this.surgeProtectorStatus;
      copy.residualCurrentStatus = this.residualCurrentStatus;

      return copy;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_4 voltage;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 current;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 peakCurrent;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 residualCurrent;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 residualDCCurrent;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activePower;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 reactivePower;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 apparentPower;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 powerFactor;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 displacementPowerFactor;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activeEnergy;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 apparentEnergy;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 unbalancedCurrent;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 lineFrequency;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 phaseAngle;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 crestFactor;
    public com.raritan.idl.sensors.StateSensor_4_0_4 powerQuality;
    public com.raritan.idl.sensors.StateSensor_4_0_4 surgeProtectorStatus;
    public com.raritan.idl.pdumodel.ResidualCurrentStateSensor_2_0_4 residualCurrentStatus;
  }

  static public class Settings implements Cloneable {
    public Settings() {
      this.name = new String();
    }

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;

      return copy;
    }

    public String name;
  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet_2_0_5.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Inlet_2_0_5.Settings oldSettings;
    public com.raritan.idl.pdumodel.Inlet_2_0_5.Settings newSettings;
  }

  public class EnableStateChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet_2_0_5.EnableStateChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public boolean enabled;
  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_5.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_5.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.Pole_6_0_0> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_5.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Inlet_2_0_5.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_2_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_2_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

  Void setEnabled(boolean enabled) throws Exception;

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp);

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class IsEnabledResult {
    public boolean _ret_;
  }

  IsEnabledResult isEnabled() throws Exception;

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp);

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp, RpcCtrl rpcCtrl);

}
