// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from PowerMeterController.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface PowerMeterController_1_1_6 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeterController:1.1.6", null);

  public static final int ERR_INVALID_PARAM = 1;

  public static final int ERR_METER_BOARD_BUSY = 2;

  static public class ScanResult implements Cloneable {
    public ScanResult() {
      this.present = new Boolean(false);
      this.meterCount = new Integer(0);
    }

    public Object clone() {
      ScanResult copy = new ScanResult();

      copy.present = this.present;
      copy.meterCount = this.meterCount;

      return copy;
    }

    public boolean present;
    public int meterCount;
  }

  public class ScanMeterBoardResult {
    public int _ret_;
    public com.raritan.idl.pdumodel.PowerMeterController_1_1_6.ScanResult result;
  }

  ScanMeterBoardResult scanMeterBoard(int powerMeterId) throws Exception;

  AsyncRequest scanMeterBoard(int powerMeterId, AsyncRpcResponse<ScanMeterBoardResult> rsp);

  AsyncRequest scanMeterBoard(int powerMeterId, AsyncRpcResponse<ScanMeterBoardResult> rsp, RpcCtrl rpcCtrl);


  public class PowerMeterCreatedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeterController_1_1_6.PowerMeterCreatedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.PowerMeter_1_1_6 powerMeter;
    public com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config;
    public com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings settings;
  }

  public class PowerMeterDeletedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeterController_1_1_6.PowerMeterDeletedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config;
    public com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings settings;
  }

  public class PanelCreatedEvent extends com.raritan.idl.pdumodel.PowerMeterController_1_1_6.PowerMeterCreatedEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeterController_1_1_6.PanelCreatedEvent:1.0.0", com.raritan.idl.pdumodel.PowerMeterController_1_1_6.PowerMeterCreatedEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Panel_1_1_6.PanelSettings panelSettings;
  }

  public class PanelDeletedEvent extends com.raritan.idl.pdumodel.PowerMeterController_1_1_6.PowerMeterDeletedEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeterController_1_1_6.PanelDeletedEvent:1.0.0", com.raritan.idl.pdumodel.PowerMeterController_1_1_6.PowerMeterDeletedEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Panel_1_1_6.PanelSettings panelSettings;
  }

  public class GetPowerMetersResult {
    public java.util.Map<Integer, com.raritan.idl.pdumodel.PowerMeter_1_1_6> _ret_;
  }

  GetPowerMetersResult getPowerMeters() throws Exception;

  AsyncRequest getPowerMeters(AsyncRpcResponse<GetPowerMetersResult> rsp);

  AsyncRequest getPowerMeters(AsyncRpcResponse<GetPowerMetersResult> rsp, RpcCtrl rpcCtrl);


  public class CreatePowerMeterResult {
    public int _ret_;
    public com.raritan.idl.pdumodel.PowerMeter_1_1_6 powerMeter;
  }

  CreatePowerMeterResult createPowerMeter(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings settings) throws Exception;

  AsyncRequest createPowerMeter(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings settings, AsyncRpcResponse<CreatePowerMeterResult> rsp);

  AsyncRequest createPowerMeter(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings settings, AsyncRpcResponse<CreatePowerMeterResult> rsp, RpcCtrl rpcCtrl);


  public class CreatePanelResult {
    public int _ret_;
    public com.raritan.idl.pdumodel.Panel_1_1_6 panel;
  }

  CreatePanelResult createPanel(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings powerMeterSettings, com.raritan.idl.pdumodel.Panel_1_1_6.PanelSettings panelSettings) throws Exception;

  AsyncRequest createPanel(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings powerMeterSettings, com.raritan.idl.pdumodel.Panel_1_1_6.PanelSettings panelSettings, AsyncRpcResponse<CreatePanelResult> rsp);

  AsyncRequest createPanel(com.raritan.idl.pdumodel.PowerMeter_1_1_6.Config config, com.raritan.idl.pdumodel.PowerMeter_1_1_6.Settings powerMeterSettings, com.raritan.idl.pdumodel.Panel_1_1_6.PanelSettings panelSettings, AsyncRpcResponse<CreatePanelResult> rsp, RpcCtrl rpcCtrl);


  public class DeletePowerMeterResult {
    public int _ret_;
  }

  DeletePowerMeterResult deletePowerMeter(int powerMeterId) throws Exception;

  AsyncRequest deletePowerMeter(int powerMeterId, AsyncRpcResponse<DeletePowerMeterResult> rsp);

  AsyncRequest deletePowerMeter(int powerMeterId, AsyncRpcResponse<DeletePowerMeterResult> rsp, RpcCtrl rpcCtrl);

}
