// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from AlertedSensorManager.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface AlertedSensorManager_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager:1.0.1", null);

  public enum AlertState {
    UNAVAILABLE,
    NORMAL,
    CRITICAL,
    WARNED;
  }

  static public class SensorCounts implements Cloneable {
    public SensorCounts() {
      this.total = new Integer(0);
      this.unavailable = new Integer(0);
      this.critical = new Integer(0);
      this.warned = new Integer(0);
    }

    public Object clone() {
      SensorCounts copy = new SensorCounts();

      copy.total = this.total;
      copy.unavailable = this.unavailable;
      copy.critical = this.critical;
      copy.warned = this.warned;

      return copy;
    }

    public int total;
    public int unavailable;
    public int critical;
    public int warned;
  }

  static public class SensorData implements Cloneable {
    public SensorData() {
      this.sensor = null;
      this.parent = null;
      this.alertState = com.raritan.idl.sensors.AlertedSensorManager_1_0_1.AlertState.values()[0];
    }

    public Object clone() {
      SensorData copy = new SensorData();

      copy.sensor = this.sensor;
      copy.parent = this.parent;
      copy.alertState = this.alertState;

      return copy;
    }

    public com.raritan.idl.sensors.Sensor_4_0_3 sensor;
    public Object parent;
    public com.raritan.idl.sensors.AlertedSensorManager_1_0_1.AlertState alertState;
  }

  public class MonitoredSensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager_1_0_1.MonitoredSensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorCounts counts;
  }

  public class AlertedSensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager_1_0_1.AlertedSensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorCounts counts;
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorData> changedSensors;
    public java.util.List<com.raritan.idl.sensors.Sensor_4_0_3> removedSensors;
  }

  public class GetSensorCountsResult {
    public com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorCounts _ret_;
  }

  GetSensorCountsResult getSensorCounts() throws Exception;

  AsyncRequest getSensorCounts(AsyncRpcResponse<GetSensorCountsResult> rsp);

  AsyncRequest getSensorCounts(AsyncRpcResponse<GetSensorCountsResult> rsp, RpcCtrl rpcCtrl);


  public class GetAllSensorsResult {
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorData> _ret_;
  }

  GetAllSensorsResult getAllSensors() throws Exception;

  AsyncRequest getAllSensors(AsyncRpcResponse<GetAllSensorsResult> rsp);

  AsyncRequest getAllSensors(AsyncRpcResponse<GetAllSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetAlertedSensorsResult {
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_1.SensorData> _ret_;
  }

  GetAlertedSensorsResult getAlertedSensors() throws Exception;

  AsyncRequest getAlertedSensors(AsyncRpcResponse<GetAlertedSensorsResult> rsp);

  AsyncRequest getAlertedSensors(AsyncRpcResponse<GetAlertedSensorsResult> rsp, RpcCtrl rpcCtrl);

}
