// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from NumericSensor.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface NumericSensor_4_0_1 extends com.raritan.idl.sensors.Sensor_4_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor:4.0.1", null);

  public static final int THRESHOLD_OUT_OF_RANGE = 1;

  public static final int THRESHOLD_INVALID = 2;

  public static final int THRESHOLD_NOT_SUPPORTED = 3;

  static public class Range implements Cloneable {
    public Range() {
      this.lower = new Double(0.0);
      this.upper = new Double(0.0);
    }

    public Object clone() {
      Range copy = new Range();

      copy.lower = this.lower;
      copy.upper = this.upper;

      return copy;
    }

    public double lower;
    public double upper;
  }

  static public class ThresholdCapabilities implements Cloneable {
    public ThresholdCapabilities() {
      this.hasUpperCritical = new Boolean(false);
      this.hasUpperWarning = new Boolean(false);
      this.hasLowerWarning = new Boolean(false);
      this.hasLowerCritical = new Boolean(false);
    }

    public Object clone() {
      ThresholdCapabilities copy = new ThresholdCapabilities();

      copy.hasUpperCritical = this.hasUpperCritical;
      copy.hasUpperWarning = this.hasUpperWarning;
      copy.hasLowerWarning = this.hasLowerWarning;
      copy.hasLowerCritical = this.hasLowerCritical;

      return copy;
    }

    public boolean hasUpperCritical;
    public boolean hasUpperWarning;
    public boolean hasLowerWarning;
    public boolean hasLowerCritical;
  }

  static public class MetaData implements Cloneable {
    public MetaData() {
      this.type = new com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec();
      this.decdigits = new Integer(0);
      this.accuracy = new Float(0.0);
      this.resolution = new Float(0.0);
      this.tolerance = new Float(0.0);
      this.noiseThreshold = new Float(0.0);
      this.range = new com.raritan.idl.sensors.NumericSensor_4_0_1.Range();
      this.thresholdCaps = new com.raritan.idl.sensors.NumericSensor_4_0_1.ThresholdCapabilities();
    }

    public Object clone() {
      MetaData copy = new MetaData();

      Object typeCopy = this.type.clone();
      copy.type = (com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec) typeCopy;
      copy.decdigits = this.decdigits;
      copy.accuracy = this.accuracy;
      copy.resolution = this.resolution;
      copy.tolerance = this.tolerance;
      copy.noiseThreshold = this.noiseThreshold;
      Object rangeCopy = this.range.clone();
      copy.range = (com.raritan.idl.sensors.NumericSensor_4_0_1.Range) rangeCopy;
      Object thresholdCapsCopy = this.thresholdCaps.clone();
      copy.thresholdCaps = (com.raritan.idl.sensors.NumericSensor_4_0_1.ThresholdCapabilities) thresholdCapsCopy;

      return copy;
    }

    public com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec type;
    public int decdigits;
    public float accuracy;
    public float resolution;
    public float tolerance;
    public float noiseThreshold;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Range range;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.ThresholdCapabilities thresholdCaps;
  }

  static public class Thresholds implements Cloneable {
    public Thresholds() {
      this.upperCriticalActive = new Boolean(false);
      this.upperCritical = new Double(0.0);
      this.upperWarningActive = new Boolean(false);
      this.upperWarning = new Double(0.0);
      this.lowerWarningActive = new Boolean(false);
      this.lowerWarning = new Double(0.0);
      this.lowerCriticalActive = new Boolean(false);
      this.lowerCritical = new Double(0.0);
      this.assertionTimeout = new Integer(0);
      this.deassertionHysteresis = new Float(0.0);
    }

    public Object clone() {
      Thresholds copy = new Thresholds();

      copy.upperCriticalActive = this.upperCriticalActive;
      copy.upperCritical = this.upperCritical;
      copy.upperWarningActive = this.upperWarningActive;
      copy.upperWarning = this.upperWarning;
      copy.lowerWarningActive = this.lowerWarningActive;
      copy.lowerWarning = this.lowerWarning;
      copy.lowerCriticalActive = this.lowerCriticalActive;
      copy.lowerCritical = this.lowerCritical;
      copy.assertionTimeout = this.assertionTimeout;
      copy.deassertionHysteresis = this.deassertionHysteresis;

      return copy;
    }

    public boolean upperCriticalActive;
    public double upperCritical;
    public boolean upperWarningActive;
    public double upperWarning;
    public boolean lowerWarningActive;
    public double lowerWarning;
    public boolean lowerCriticalActive;
    public double lowerCritical;
    public int assertionTimeout;
    public float deassertionHysteresis;
  }

  static public class Reading implements Cloneable {
    public Reading() {
      this.timestamp = new java.util.Date(0);
      this.available = new Boolean(false);
      this.status = new com.raritan.idl.sensors.NumericSensor_4_0_1.Reading.Status();
      this.valid = new Boolean(false);
      this.value = new Double(0.0);
    }

    public Object clone() {
      Reading copy = new Reading();

      copy.timestamp = this.timestamp;
      copy.available = this.available;
      Object statusCopy = this.status.clone();
      copy.status = (com.raritan.idl.sensors.NumericSensor_4_0_1.Reading.Status) statusCopy;
      copy.valid = this.valid;
      copy.value = this.value;

      return copy;
    }


    static public class Status implements Cloneable {
      public Status() {
        this.aboveUpperCritical = new Boolean(false);
        this.aboveUpperWarning = new Boolean(false);
        this.belowLowerWarning = new Boolean(false);
        this.belowLowerCritical = new Boolean(false);
      }

      public Object clone() {
        Status copy = new Status();

        copy.aboveUpperCritical = this.aboveUpperCritical;
        copy.aboveUpperWarning = this.aboveUpperWarning;
        copy.belowLowerWarning = this.belowLowerWarning;
        copy.belowLowerCritical = this.belowLowerCritical;

        return copy;
      }

      public boolean aboveUpperCritical;
      public boolean aboveUpperWarning;
      public boolean belowLowerWarning;
      public boolean belowLowerCritical;
    }
    public java.util.Date timestamp;
    public boolean available;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Reading.Status status;
    public boolean valid;
    public double value;
  }

  public class ReadingChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_1.ReadingChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_1.Reading newReading;
  }

  public class StateChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_1.StateChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_1.Reading oldReading;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Reading newReading;
  }

  public class MetaDataChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_1.MetaDataChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_1.MetaData oldMetaData;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.MetaData newMetaData;
  }

  public class ThresholdsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_1.ThresholdsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds oldThresholds;
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds newThresholds;
  }

  public class GetMetaDataResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetDefaultThresholdsResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds _ret_;
  }

  GetDefaultThresholdsResult getDefaultThresholds() throws Exception;

  AsyncRequest getDefaultThresholds(AsyncRpcResponse<GetDefaultThresholdsResult> rsp);

  AsyncRequest getDefaultThresholds(AsyncRpcResponse<GetDefaultThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class GetThresholdsResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds _ret_;
  }

  GetThresholdsResult getThresholds() throws Exception;

  AsyncRequest getThresholds(AsyncRpcResponse<GetThresholdsResult> rsp);

  AsyncRequest getThresholds(AsyncRpcResponse<GetThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class SetThresholdsResult {
    public int _ret_;
  }

  SetThresholdsResult setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds thresh) throws Exception;

  AsyncRequest setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds thresh, AsyncRpcResponse<SetThresholdsResult> rsp);

  AsyncRequest setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_1.Thresholds thresh, AsyncRpcResponse<SetThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class GetReadingResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_1.Reading _ret_;
  }

  GetReadingResult getReading() throws Exception;

  AsyncRequest getReading(AsyncRpcResponse<GetReadingResult> rsp);

  AsyncRequest getReading(AsyncRpcResponse<GetReadingResult> rsp, RpcCtrl rpcCtrl);

}
