// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DoorAccessControl.idl.

package com.raritan.idl.smartlock;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface DoorAccessControl {
  static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl:1.0.0", null);

  public static final int ERR_INVALID_SETTINGS = 1;

  public static final int ERR_NO_SUCH_ID = 2;

  public static final int ERR_MAX_RULES_REACHED = 3;

  static public class AbsoluteTimeCondition implements Cloneable {
    public AbsoluteTimeCondition() {
      this.enabled = new Boolean(false);
      this.validFrom = new java.util.Date(0);
      this.validTill = new java.util.Date(0);
    }

    public Object clone() {
      AbsoluteTimeCondition copy = new AbsoluteTimeCondition();

      copy.enabled = this.enabled;
      copy.validFrom = this.validFrom;
      copy.validTill = this.validTill;

      return copy;
    }

    public boolean enabled;
    public java.util.Date validFrom;
    public java.util.Date validTill;
  }

  static public class PeriodicTimeCondition implements Cloneable {
    public PeriodicTimeCondition() {
      this.enabled = new Boolean(false);
      this.daysOfWeek = new java.util.ArrayList<Integer>();
      this.fromHourOfDay = new Integer(0);
      this.tillHourOfDay = new Integer(0);
      this.fromMinuteOfHour = new Integer(0);
      this.tillMinuteOfHour = new Integer(0);
    }

    public Object clone() {
      PeriodicTimeCondition copy = new PeriodicTimeCondition();

      copy.enabled = this.enabled;
      copy.daysOfWeek = new java.util.ArrayList<Integer>(this.daysOfWeek);
      copy.fromHourOfDay = this.fromHourOfDay;
      copy.tillHourOfDay = this.tillHourOfDay;
      copy.fromMinuteOfHour = this.fromMinuteOfHour;
      copy.tillMinuteOfHour = this.tillMinuteOfHour;

      return copy;
    }

    public boolean enabled;
    public java.util.List<Integer> daysOfWeek;
    public int fromHourOfDay;
    public int tillHourOfDay;
    public int fromMinuteOfHour;
    public int tillMinuteOfHour;
  }

  static public class CardReaderInfo implements Cloneable {
    public CardReaderInfo() {
      this.linkId = new Integer(0);
      this.position = new String();
    }

    public Object clone() {
      CardReaderInfo copy = new CardReaderInfo();

      copy.linkId = this.linkId;
      copy.position = this.position;

      return copy;
    }

    public int linkId;
    public String position;
  }

  static public class KeypadInfo implements Cloneable {
    public KeypadInfo() {
      this.linkId = new Integer(0);
      this.position = new String();
    }

    public Object clone() {
      KeypadInfo copy = new KeypadInfo();

      copy.linkId = this.linkId;
      copy.position = this.position;

      return copy;
    }

    public int linkId;
    public String position;
  }

  static public class CardCondition implements Cloneable {
    public CardCondition() {
      this.enabled = new Boolean(false);
      this.cardUid = new String();
      this.cardReader = new com.raritan.idl.smartlock.DoorAccessControl.CardReaderInfo();
    }

    public Object clone() {
      CardCondition copy = new CardCondition();

      copy.enabled = this.enabled;
      copy.cardUid = this.cardUid;
      Object cardReaderCopy = this.cardReader.clone();
      copy.cardReader = (com.raritan.idl.smartlock.DoorAccessControl.CardReaderInfo) cardReaderCopy;

      return copy;
    }

    public boolean enabled;
    public String cardUid;
    public com.raritan.idl.smartlock.DoorAccessControl.CardReaderInfo cardReader;
  }

  static public class KeypadCondition implements Cloneable {
    public KeypadCondition() {
      this.enabled = new Boolean(false);
      this.pin = new String();
      this.keypad = new com.raritan.idl.smartlock.DoorAccessControl.KeypadInfo();
    }

    public Object clone() {
      KeypadCondition copy = new KeypadCondition();

      copy.enabled = this.enabled;
      copy.pin = this.pin;
      Object keypadCopy = this.keypad.clone();
      copy.keypad = (com.raritan.idl.smartlock.DoorAccessControl.KeypadInfo) keypadCopy;

      return copy;
    }

    public boolean enabled;
    public String pin;
    public com.raritan.idl.smartlock.DoorAccessControl.KeypadInfo keypad;
  }

  static public class DoorAccessRule implements Cloneable {
    public DoorAccessRule() {
      this.name = new String();
      this.doorHandleLocks = new java.util.ArrayList<com.raritan.idl.peripheral.DeviceSlot_3_0_0>();
      this.cardCondition1 = new com.raritan.idl.smartlock.DoorAccessControl.CardCondition();
      this.cardCondition2 = new com.raritan.idl.smartlock.DoorAccessControl.CardCondition();
      this.keypadCondition1 = new com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition();
      this.keypadCondition2 = new com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition();
      this.conditionsTimeout = new Integer(0);
      this.absoluteTime = new com.raritan.idl.smartlock.DoorAccessControl.AbsoluteTimeCondition();
      this.periodicTime = new com.raritan.idl.smartlock.DoorAccessControl.PeriodicTimeCondition();
    }

    public Object clone() {
      DoorAccessRule copy = new DoorAccessRule();

      copy.name = this.name;
      copy.doorHandleLocks = new java.util.ArrayList<com.raritan.idl.peripheral.DeviceSlot_3_0_0>(this.doorHandleLocks);
      Object cardCondition1Copy = this.cardCondition1.clone();
      copy.cardCondition1 = (com.raritan.idl.smartlock.DoorAccessControl.CardCondition) cardCondition1Copy;
      Object cardCondition2Copy = this.cardCondition2.clone();
      copy.cardCondition2 = (com.raritan.idl.smartlock.DoorAccessControl.CardCondition) cardCondition2Copy;
      Object keypadCondition1Copy = this.keypadCondition1.clone();
      copy.keypadCondition1 = (com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition) keypadCondition1Copy;
      Object keypadCondition2Copy = this.keypadCondition2.clone();
      copy.keypadCondition2 = (com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition) keypadCondition2Copy;
      copy.conditionsTimeout = this.conditionsTimeout;
      Object absoluteTimeCopy = this.absoluteTime.clone();
      copy.absoluteTime = (com.raritan.idl.smartlock.DoorAccessControl.AbsoluteTimeCondition) absoluteTimeCopy;
      Object periodicTimeCopy = this.periodicTime.clone();
      copy.periodicTime = (com.raritan.idl.smartlock.DoorAccessControl.PeriodicTimeCondition) periodicTimeCopy;

      return copy;
    }

    public String name;
    public java.util.List<com.raritan.idl.peripheral.DeviceSlot_3_0_0> doorHandleLocks;
    public com.raritan.idl.smartlock.DoorAccessControl.CardCondition cardCondition1;
    public com.raritan.idl.smartlock.DoorAccessControl.CardCondition cardCondition2;
    public com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition keypadCondition1;
    public com.raritan.idl.smartlock.DoorAccessControl.KeypadCondition keypadCondition2;
    public int conditionsTimeout;
    public com.raritan.idl.smartlock.DoorAccessControl.AbsoluteTimeCondition absoluteTime;
    public com.raritan.idl.smartlock.DoorAccessControl.PeriodicTimeCondition periodicTime;
  }

  public enum DoorAccessDenialReason {
    DENIED_NO_MATCHING_RULE,
    DENIED_ABSOLUTE_TIME_CONDITION,
    DENIED_PERIODIC_TIME_CONDITION,
    DENIED_CONDITIONS_TIMEOUT;
  }

  public class DoorAccessGrantedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl.DoorAccessGrantedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int ruleId;
    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule;
  }

  public class DoorAccessDeniedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl.DoorAccessDeniedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessDenialReason reason;
    public int ruleId;
    public String ruleName;
  }

  public class DoorAccessRuleAddedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl.DoorAccessRuleAddedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int ruleId;
    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule;
  }

  public class DoorAccessRuleChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl.DoorAccessRuleChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int ruleId;
    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule oldRule;
    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule newRule;
  }

  public class DoorAccessRuleDeletedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.DoorAccessControl.DoorAccessRuleDeletedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int ruleId;
    public com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule;
  }

  public class GetDoorAccessRulesResult {
    public java.util.Map<Integer, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule> _ret_;
  }

  GetDoorAccessRulesResult getDoorAccessRules() throws Exception;

  AsyncRequest getDoorAccessRules(AsyncRpcResponse<GetDoorAccessRulesResult> rsp);

  AsyncRequest getDoorAccessRules(AsyncRpcResponse<GetDoorAccessRulesResult> rsp, RpcCtrl rpcCtrl);


  public class SetAllDoorAccessRulesResult {
    public int _ret_;
    public java.util.List<Integer> invalidRuleIds;
  }

  SetAllDoorAccessRulesResult setAllDoorAccessRules(java.util.Map<Integer, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule> rules) throws Exception;

  AsyncRequest setAllDoorAccessRules(java.util.Map<Integer, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule> rules, AsyncRpcResponse<SetAllDoorAccessRulesResult> rsp);

  AsyncRequest setAllDoorAccessRules(java.util.Map<Integer, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule> rules, AsyncRpcResponse<SetAllDoorAccessRulesResult> rsp, RpcCtrl rpcCtrl);


  public class AddDoorAccessRuleResult {
    public int _ret_;
    public int ruleId;
  }

  AddDoorAccessRuleResult addDoorAccessRule(com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule) throws Exception;

  AsyncRequest addDoorAccessRule(com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule, AsyncRpcResponse<AddDoorAccessRuleResult> rsp);

  AsyncRequest addDoorAccessRule(com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule rule, AsyncRpcResponse<AddDoorAccessRuleResult> rsp, RpcCtrl rpcCtrl);


  public class ModifyDoorAccessRuleResult {
    public int _ret_;
  }

  ModifyDoorAccessRuleResult modifyDoorAccessRule(int id, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule modifiedRule) throws Exception;

  AsyncRequest modifyDoorAccessRule(int id, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule modifiedRule, AsyncRpcResponse<ModifyDoorAccessRuleResult> rsp);

  AsyncRequest modifyDoorAccessRule(int id, com.raritan.idl.smartlock.DoorAccessControl.DoorAccessRule modifiedRule, AsyncRpcResponse<ModifyDoorAccessRuleResult> rsp, RpcCtrl rpcCtrl);


  public class DeleteDoorAccessRuleResult {
    public int _ret_;
  }

  DeleteDoorAccessRuleResult deleteDoorAccessRule(int id) throws Exception;

  AsyncRequest deleteDoorAccessRule(int id, AsyncRpcResponse<DeleteDoorAccessRuleResult> rsp);

  AsyncRequest deleteDoorAccessRule(int id, AsyncRpcResponse<DeleteDoorAccessRuleResult> rsp, RpcCtrl rpcCtrl);

}
