// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Webcam.idl.

package com.raritan.json_rpc.webcam;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Webcam_Proxy extends ObjectProxy implements com.raritan.idl.webcam.Webcam {

  public Webcam_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Webcam_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.webcam.Webcam.typeInfo);
  }

  public static Webcam_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Webcam_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetInformationResult getInformation() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getInformation", params);
    GetInformationResult ret = new GetInformationResult();
    ret._ret_ = com.raritan.json_rpc.webcam.Information_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getInformation(final AsyncRpcResponse<GetInformationResult> rsp) {
    return getInformation(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getInformation(final AsyncRpcResponse<GetInformationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getInformation", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetInformationResult ret = new GetInformationResult();
          ret._ret_ = com.raritan.json_rpc.webcam.Information_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetSettingsResult getSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSettings", params);
    GetSettingsResult ret = new GetSettingsResult();
    ret._ret_ = com.raritan.json_rpc.webcam.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp) {
    return getSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSettingsResult ret = new GetSettingsResult();
          ret._ret_ = com.raritan.json_rpc.webcam.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetSettingsResult setSettings(final com.raritan.idl.webcam.Settings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", com.raritan.json_rpc.webcam.Settings_Codec.encode(settings));
    final JSONObject result = rpcCall("setSettings", params);
    SetSettingsResult ret = new SetSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.webcam.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp) {
    return setSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.webcam.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", com.raritan.json_rpc.webcam.Settings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetSettingsResult ret = new SetSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public CaptureImageResult captureImage() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("captureImage", params);
    CaptureImageResult ret = new CaptureImageResult();
    ret._ret_ = com.raritan.json_rpc.webcam.Image_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest captureImage(final AsyncRpcResponse<CaptureImageResult> rsp) {
    return captureImage(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest captureImage(final AsyncRpcResponse<CaptureImageResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("captureImage", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CaptureImageResult ret = new CaptureImageResult();
          ret._ret_ = com.raritan.json_rpc.webcam.Image_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public TriggerCaptureResult triggerCapture() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("triggerCapture", params);
    TriggerCaptureResult ret = new TriggerCaptureResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest triggerCapture(final AsyncRpcResponse<TriggerCaptureResult> rsp) {
    return triggerCapture(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest triggerCapture(final AsyncRpcResponse<TriggerCaptureResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("triggerCapture", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          TriggerCaptureResult ret = new TriggerCaptureResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
